#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Compression=4
#EndRegion 

#Region #### AutoIt Includes ####
#include <Array.au3>
#include <Clipboard.au3>
#include <ColorConstants.au3>
;~ #include 'Datenaufnahme.au3'
#Include <File.au3>
;~ #include '_FileCopyEx.au3'
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GUIconstants.au3>
#include <Misc.au3>
#include <MsgBoxConstants.au3>
#include <Process.au3>
#include <ScreenCapture.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#EndRegion #### AutoIt Includes ####


SplashOff()
Opt('GUICloseOnEsc', 0)
 
Global $sTitle = ' myBackup - '
Global $sVersion = '1.0.3'
Global $sDate = '28.08.2017'
 
Global $hGui = GUICreate(StringFormat('%s v%3.5s', $sTitle, $sVersion), 302,300,-1,300) ; Fenster erstellen
GUISetIcon('shell32.dll', 32) ; Icon für das Fenster festlegen
;~ GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseGui') ; Funktion die beim schließen des Fensters aufgerufen wird

Global $i_FontSize = 9
Global $i_FontWeight = 800
Global $s_FontName = 'Lucida Console'
GUISetBkColor(0xFFFABB)

$Label_1=GuiCtrlCreateLabel("Status:",26,10,50,15)
$Label_2=GuiCtrlCreateLabel("Kein USB-Medium gefunden!",70,10,200,15)
         GuiCtrlSetFont($Label_2,$i_FontSize,$i_FontWeight)
         GUICtrlSetColor($Label_2, $COLOR_RED)
         GUICtrlCreateGroup("  Ziellaufwerk wählen                                 Freier Platz", 10, 115, 281, 80) ; Umrandung Ziellaufwerk
$Label_3=GuiCtrlCreateLabel("Größe der zu sichernden Daten:" ,26,30,270,15)
$Label_4=GuiCtrlCreateLabel("GB",197,30,75,15,0x2) ; 0x2 mittig
         GuiCtrlSetFont($Label_4,$i_FontSize,$i_FontWeight)
         GUICtrlSetColor($Label_4, $COLOR_RED)
		GUICtrlCreateGroup("", 10, 55, 281, 50)  ; Umrandung Outlook             

$Label_5=GuiCtrlCreateLabel("Outlook ",26,55,50,15)  
Local $Outlook = GUICtrlCreateCheckbox("Persönliche Ordner sichern", 26, 75, 200, 20)
GUICtrlSetState(-1, 0) ; unchecked

$btnBackup = GUICtrlCreateButton("  Backup  ", 26, 250) 	; Create a button to start the backup process

$btnIni = GUICtrlCreateButton("  Edit ini...  ", 120, 250) 	; Create a button to start the backup process

$btnRestore = GUICtrlCreateButton("  Restore  ", 215, 250); Create a button to start the backup process

$hStart = GUICtrlCreateButton('Ausgewählte Volumes anzeigen', 15, 200, 275, 25)

#EndRegion ### GUI_Draw ####

#Region ### ini_read ####
If Not FileExists(@ScriptDir & "\myBackup.ini") Then
              
            _ini_create()

EndIf
 
Global $q_Array = IniReadSection(@ScriptDir & "\myBackup.ini", "Quellen")
Global $z_Array = IniReadSection(@ScriptDir & "\myBackup.ini", "Ziel")

Global $Backup_Ziel_Verzeichnis = ($z_Array[1][1] )
 
If $Backup_Ziel_Verzeichnis = "@ScriptDir" Then
              $Backup_Ziel_Verzeichnis= StringReplace($Backup_Ziel_Verzeichnis,"@ScriptDir",@ScriptDir)
              $Backup_Ziel_Verzeichnis= ($Backup_Ziel_Verzeichnis &"\Backup\")
EndIf
 
              local $tmp = 0
              For $i = 1 To $q_Array[0][0]
 
                $array_Quelle = ($q_Array[$i][1])
                $Quell_Verzeichnis = StringReplace($array_Quelle, "*Userprofil*", @UserProfileDir)
                $Quell_Laufwerk = StringLeft($Quell_Verzeichnis,3)
                $Quell_Buchstabe = StringLeft($Quell_Verzeichnis,1)                          
                Local $Ordner = DirGetSize($q_Array[$i][1])                                                                                                                                                      
                DirGetSize($Quell_Verzeichnis)
                $tmp +=($Ordner) ;Größe zusammenrechnen

                Next
      
				GUICtrlSetData($Label_3,"Größe der zu sichernden Daten:")
                $gesammt = GUICtrlSetData($Label_4, round(($tmp /1024 /1024), 0) & " MB")

#EndRegion ### ini_read ####

GUISetState(@SW_SHOW, $hGui) ; Show GUI

_USB_Medium() ;Ist ein USB-Medium angeschlossen?

#Region ### _ini_create ####
Func _ini_create()
	
              ; Create a constant variable in Local scope of the filepath that will be read/written to.
              Local Const $sFilePath = @ScriptDir & "\myBackup.ini"
 
              ; Create a temporary file to write data to.
              If Not FileWrite($sFilePath, "" & @CRLF) Then
                            MsgBox($MB_SYSTEMMODAL, "", "Fehler - ini- Datei kann nicht erstellt werden!")
                            Return False
              EndIf
 
              ; Open the file for writing (append to the end of a file) and store the handle to a variable.
              Local $hFileOpen = FileOpen($sFilePath, $FO_APPEND)
              If $hFileOpen = -1 Then
                            MsgBox($MB_SYSTEMMODAL, "", "An error occurred whilst writing the temporary file.")
                            Return False
              EndIf
                            
              ; Write data to the file using the handle returned by FileOpen.
            FileWrite($hFileOpen, "In dieser Datei werden die zu sichernden Pfade festgelegt, die mit dem myBackup Tool gesichert werden sollen" & @CRLF)
            FileWrite($hFileOpen, "" & @CRLF)
            FileWrite($hFileOpen, "-------------------------------------       Bitte hier keine änderung vornehmen!      -------------------------------------" & @CRLF)
            FileWrite($hFileOpen, "[Quellen]" & @CRLF)
            FileWrite($hFileOpen, "1=" & @DesktopDir & @CRLF)
            FileWrite($hFileOpen, "2=" & @MyDocumentsDir & @CRLF)
            FileWrite($hFileOpen, "3=" & @UserProfileDir & "\Downloads" & @CRLF)
            FileWrite($hFileOpen, "4=" & @UserProfileDir & "\Favorites" & @CRLF)
            FileWrite($hFileOpen, "5=" & @UserProfileDir & "\Music" & @CRLF)
            FileWrite($hFileOpen, "6=" & @UserProfileDir & "\Pictures" & @CRLF)
            FileWrite($hFileOpen, "7=" & @UserProfileDir & "\Videos" & @CRLF)
            FileWrite($hFileOpen, "8=" & @UserProfileDir & "\Links" & @CRLF)
            FileWrite($hFileOpen, "9=" & @UserProfileDir & "\Documentum" & @CRLF)
            FileWrite($hFileOpen, "10=" & @LocalAppDataDir & "\Microsoft\OneNote" & @CRLF)
            FileWrite($hFileOpen, "11=" & @LocalAppDataDir & "\Microsoft\FORMS" & @CRLF) 
            FileWrite($hFileOpen, "12=" & @LocalAppDataDir & "\Microsoft\Excel" & @CRLF)
            FileWrite($hFileOpen, "13=" & @LocalAppDataDir & "\Microsoft\Internet Explorer" & @CRLF)
            FileWrite($hFileOpen, "14=" & @LocalAppDataDir & "\Microsoft\Office" & @CRLF)
            FileWrite($hFileOpen, "15=" & @LocalAppDataDir & "\Microsoft\Templates" & @CRLF)
            FileWrite($hFileOpen, "16=" & @LocalAppDataDir & "\Microsoft\Windows" & @CRLF)
            FileWrite($hFileOpen, "17=" & @AppDataDir & "\Microsoft\Signatures" & @CRLF)
            FileWrite($hFileOpen, "18=" & @AppDataDir & "\Microsoft\Office" & @CRLF)
            FileWrite($hFileOpen, "19=" & @AppDataDir & "\Microsoft\Sticky Notes" & @CRLF)
            FileWrite($hFileOpen, "20=" & @AppDataDir & "\Microsoft\Templates" & @CRLF)
            FileWrite($hFileOpen, "21=" & @AppDataDir & "\Mozilla\Firefox" & @CRLF)
            FileWrite($hFileOpen, "22=" & @CRLF)
            FileWrite($hFileOpen, "-------------------------------------                     ENDE                      -------------------------------------" & @CRLF)
            FileWrite($hFileOpen, "" & @CRLF)     
            FileWrite($hFileOpen, "" & @CRLF)    
            FileWrite($hFileOpen, "-------------------------------------      Der Bereich für Ihre einstellungen       -------------------------------------" & @CRLF)
			FileWrite($hFileOpen, "" & @CRLF)       
            FileWrite($hFileOpen, "50=" & @CRLF)
            FileWrite($hFileOpen, "" & @CRLF)
            FileWrite($hFileOpen, "-------------------------------------                     ENDE                      -------------------------------------" & @CRLF)
            FileWrite($hFileOpen, "" & @CRLF)
            FileWrite($hFileOpen, "[Ziel]" & @CRLF)
            FileWrite($hFileOpen, "1=" & @CRLF)
              
            ; Close the handle returned by FileOpen.
            FileClose($hFileOpen)

#EndRegion ### _ini_create ####

#Region ### ini_Info ####

;~ 	Local $sMsg = 'Um Backups erstellen zu können, wurde eine Standard ini (myBackup.ini) erstellt.\n\n'
;~ 	$sMsg &= 'Die sicherung umfasst folgende Ordner in Ihrem Profil:\n\n\t'
;~ 	$sMsg &= '- Bilder\n\t'
;~ 	$sMsg &= '- Downloads\n\t'
;~ 	$sMsg &= '- Documentum\n\t'
;~ 	$sMsg &= '- Eigene Dateien\n\t'
;~ 	$sMsg &= '- Internet Explorer Favoriten\n\t'
;~ 	$sMsg &= '- Links\n\t'
;~ 	$sMsg &= '- Musik\n\t'
;~ 	$sMsg &= '- Videos\n\t'
;~ 	$sMsg &= '- AppData (für weitere Informationen bitte ini öffnen)\n\n'
;~ 	$sMsg &= '\nDie ini-Datei kann im Bereich ""Ihre Einstellungen"" erweitert werden.\n'
;~ 	MsgBox(0, $sTitle & 'ini nicht gefunden!', StringFormat($sMsg), 0, $hGui)
	
GUICreate("Ini-Datei nicht gefunden...", 500, 300) ; will create a dialog box that when displayed is centered
Local $idMyedit = GUICtrlCreateEdit("",10, 10, 480, 250, $ES_READONLY)
GUISetState(@SW_SHOW)
GUICtrlSetData(-1, StringFormat("Um Backups erstellen zu können, wurde eine Standard ini (myBackup.ini) erstellt.\r\n\r\nDie Sicherung umfasst nur die Daten des aktuell angemeldeten Benutzers:\r\n\r\n"  & _
								"\r	- Bilder\r\n	- Downloads\r\n	- Documentum\r\n	- Eigene Dateien\r\n	- Fierfox Profil\r\n	- Internet Explorer Favoriten\r\n	- Links\r\n	- Musik\r\n	- Videos\r\n" & _
								"\r	- AppData (für weitere Informationen bitte ini öffnen)\r\n\r\nDie Datei kann ab Punkt 50. ihrerseits erweitert werden.\r\n"))
GUISetBkColor(0xFFFABB) ;; 0xFFFFFF)
GUICtrlSetColor(-1, 0x000000)
GUICtrlSetFont(-1, 9, 800, 0, "Arial")

	$btnOK = GUICtrlCreateButton("  OK  ", 235, 270, 50, 25); Create a button to start the backup process

	While 1
		Switch GUIGetMsg()
			
			Case $GUI_EVENT_CLOSE
				ExitLoop
				
			Case $btnOK
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete()

EndFunc   ;==>create_ini
#EndRegion ### ini_Info ####

func _USB_Medium()
              
Global $drives=DriveGetDrive("removable")
 
If @error Then
    Sleep(2000)
    MsgBox(16,"Kein USB-Stick gefunden!","Kein USB-Stick gefunden!" & @cr &  @cr & "Bitte schliessen Sie einen USB-Stick an!" & @cr & @cr & "Die Anwendung wird beendet.",20000)              
EndIf
 
dim $name[$drives[0]+1]
dim $space[$drives[0]+1]
$maxname=2
$maxspace=0
for $i=1 to $drives[0]
  $name[$i]=StringLen(DriveGetLabel($drives[$i]))
  if $name[$i]>=$maxname then
    $maxname=$name[$i]
  endif
  $space[$i]=StringLen(Round(DriveSpaceFree($drives[$i])))
  if $space[$i]>=$maxspace then
    $maxspace=$space[$i]
  endif
Next
 
 
$width=($maxname+$maxspace)+8+150
if $width<210 then $width=300              
              
GUISetFont($i_FontSize,$i_FontWeight) ;;Set general window font
For $i=1 to $drives[0]
  If $i=0 Then 
    GUICtrlSetData($Label_2,"Kein USB Medium angeschloßen!")
    Sleep(5000)
    MsgBox(16,"Kein USB-Medium gefunden!","Kein USB-Medium gefunden!" & @CR & "Die Anwendung wird jetzt beendet." & @cr & $Label_3 & " " & $Label_4,30000)      
    Exit
  Else
    If $i=NOT 0 Then        
      GUICtrlSetData($Label_2,"USB-Medium gefunden...") ;;report drives found     
    EndIf 
  EndIf
Next
              
              
dim $chkboxes[$drives[0] + 1]
$chkboxes[0]=$drives[0]
$Ypos=130
for $i=1 to $drives[0]
  $chkboxes[$i]=GUICtrlCreateRadio(StringUpper($drives[$i]), 26,$Ypos,35,20) ;; & " (" & DriveGetLabel($drives[$i]) & ")"),26,$Ypos,($maxname+5)*8,20)
  GuiCtrlSetState(-1,$GUI_UNCHECKED)
  $Ypos=$Ypos+20
next
$Ypos=130
for $i=1 to $drives[0]
  $FreeMem=GuiCtrlCreateLabel(Round(DriveSpaceFree($drives[$i])) & " MB",198,$Ypos,75,15,0x2)
  GuiCtrlSetFont($FreeMem, $i_FontSize, $i_FontWeight)
  $Ypos=$Ypos+20
next 


#Region Test
While 1
$nMsg = GUIGetMsg()
Switch $nMsg
Case -3
Exit


case else
	
$sCheckedDrives = ''
For $i = 1 To $drives[0]
If BitAND(GUICtrlRead($chkboxes[$i]), 1) Then
$sCheckedDrives &= ControlGetText("", '', $chkboxes[$i]) & ''
EndIf
Next
	

If _ArraySearch($chkboxes, $nMsg)  = -1 Then
	MsgBox(64, 'Info', 'Keine Volumes ausgewählt', 60, $hGUI)
Else
Local $sFilePath = (@ScriptDir & "\myBackup.ini")
    IniWriteSection($sFilePath, "Ziel", "1=" & $sCheckedDrives & "\myBackup_" & @UserName & "\")
	Local $aArray = IniReadSection($sFilePath, "Ziel")
    If Not @error Then
    ShellExecute("myBackup.ini")
	EndIf
EndIf



EndSwitch
WEnd
#EndRegion Test









#Region Loop
While 1
$nMsg = GUIGetMsg()
Switch $nMsg
Case -3
Exit
Case $hStart

$sCheckedDrives = ''
For $i = 1 To $drives[0]
If BitAND(GUICtrlRead($chkboxes[$i]), 1) Then
$sCheckedDrives &= ControlGetText("", '', $chkboxes[$i]) & ''
EndIf
Next

If $sCheckedDrives <> '' Then 
                
MsgBox(64, 'Info', $sCheckedDrives & "\Datensicherung_" & @UserName, 60, $hGUI)

              Local $sFilePath = (@ScriptDir & "\myBackup.ini")
 
;~               Local Const $sFilePath = (@ScriptDir & "\myBackup.ini")
               IniWriteSection($sFilePath, "Ziel", "1=" & $sCheckedDrives & "\myBackup_" & @UserName & "\")
              Local $aArray = IniReadSection($sFilePath, "Ziel")
              If Not @error Then
              ShellExecute("myBackup.ini")
              EndIf
Else
MsgBox(64, 'Info', 'Keine Volumes ausgewählt', 60, $hGUI)
EndIf





Case $Outlook 
		_Outlook()

Case $btnIni 
		_edit_ini()
 
Case $btnBackup; If backup button is pressed.
        _Backup() ; Start backup
 
Case $btnRestore; If backup button is pressed.
        _CaptureScreen() ; Start backup
 

EndSwitch
WEnd
#EndRegion

 
EndFunc  ;Ende - USB-Medium angeschlossen?

Func _edit_ini()
	
	If Not FileExists(@ScriptDir & "\myBackup.ini") Then    
            _ini_create()
		Else
		ShellExecute("myBackup.ini")
	EndIf
EndFunc


Func _Backup()
	
            For $i = 1 To $q_Array[0][0]
            $array_Quelle = ($q_Array[$i][1])
            $Quell_Verzeichnis = StringReplace($array_Quelle, "*Userprofil*", @UserProfileDir)
            $Quell_Laufwerk = StringLeft($Quell_Verzeichnis,3)
            $Quell_Buchstabe = StringLeft($Quell_Verzeichnis,1)
 
            $Backup_Ziel = StringReplace("Drive_" & $Quell_Verzeichnis, ":", "")
            $Backup_Ziel_Pfad = ( $Backup_Ziel_Verzeichnis  & $Backup_Ziel)
            $Ziel = StringReplace($Backup_Ziel_Pfad, "*Userprofil*", @UserProfileDir)                                                                                                         
            Sleep(1000)

            Global $sSourceDir = $Quell_Verzeichnis ; alle Dateien aus diesem Verzeichnis sollen kopiert werden
            Global $sDestDir = $Ziel ; die Quelldateien sollen (mit Unterverzeichnissen) in dieses Verzeichnis kopiert werden
            Global $aSourceFiles[1], $aDestDir[1]
              
            _FileCopyEx_CreateArrays($sSourceDir, $sDestDir, $aSourceFiles, $aDestDir, '*') ; diese Funktion erstellt die Arrays für _FileCopyEx
            If Not @error Then
            Global $sLog = _FileCopyEx($aSourceFiles, $aDestDir, 16 + 8 + 2 + 1, 'Dateien kopieren...') ; hier erfolgt dann das kopieren
            ConsoleWrite('Fehler: ' & @error & @CR)
            ConsoleWrite($sLog & @CR)
 
            EndIf                                              
            Next                                                       
EndFunc   ;==>_Backup
